{{

  VGA Line Driver Test
  By Dave Fletcher

  Simple animated test for the VGA Line Driver.
}}
CON
  _clkmode = xtal1+pll16x
  _clkfreq = 5_000_000

  VIDEO_PIN   = 16 ' Set for proto board. Change to suit (0, 8, 16, 24).

VAR
  LONG linebuffer[video#BUFFERSIZE]

OBJ
  video : "VGA Line Driver"
  rng   : "RealRandom"

PUB start | i, tmp

  rng.start

  repeat i from 0 to video#BUFFERSIZE step 2
    linebuffer[i] := rng.random
    linebuffer[i] |= %00000011_00000011_00000011_00000011  
    linebuffer[i+1] := %%0123_0123_0123_0123  
           
  video.start(VIDEO_PIN, @linebuffer)
  
  repeat
  
    ' Wheee!
    repeat i from 0 to video#BUFFERSIZE step 2
      ' Using a temp var wasn't so important above because the video driver
      ' wasn't running at the time. If we just stick an rng.random directly
      ' into linebuffer[i] before the bitwise OR, some of the bottom 2 bits
      ' (as described in VGA Learn.spin) will not be high between the two
      ' calls. Spin is slow, so there is actually quite a delay between calls.
      ' Frequency on hsync and vsync appears to jump high in this case because
      ' it's pulsing rather randomly and much faster than normal. Monitors
      ' will not sync.            
      tmp := rng.random
      tmp |= %00000011_00000011_00000011_00000011
      linebuffer[i] := tmp
      waitcnt(cnt+1000000)
                          